# ***************************
# ***** SPAWN PROP V2.0 *****
# ***************************
# Creator: Steven Hartin
# 
# Many thanks to the people
# on the eventscripts IRC who
# helped me complete my first
# Python Script, SuperDave,
# GodJonez and Errant especially.
# ****************************
# Requirements:
#   EventScripts v2.0.244
# ****************************
# To install:
#   Make sure this file is inside
#   ./addons/eventscripts/spawnprop
#   And you have a correct keygroup
# ****************************
# For more help, visit:
#   http://forums.mattie.info/cs/forums/viewtopic.php?t=18942
# Have fun
# ****************************

max_spawns = 5
# The maximum spawns a person is allowed in 1 round.
# 0 = Infinite

##############################
### DO NOT EDIT BELOW HERE ###
##############################

import es
import keyvalues
import popuplib
import playerlib
from es import server_var

info = es.AddonInfo()
info.name = "SpawnProp"
info.version = "2.0"
info.author = "Freddukes"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=18942"
info.description = "Allows you to spawn Props"

# Define the server variables here for global use
sp_temp = 0
temp_prop = 0
current_page = 1
current_line = 0
isthereanextpage = 0
current_spawnpopuppage = 0
which_prop = 0
current_spawnpopuppage = "spawnmenu%i"%current_page
popup_page = popuplib.create(current_spawnpopuppage)
es.ServerVar("spawnprop_version",info.version,"SpawnProp Version: The current version of the script").makepublic()

PlayerDict = {}

def unload():
    del PlayerDict

def load():
    # Load keygroups and check for scripts
    es.keygroupload('proplist','|spawnprop')
    if not es.exists('script','popup'):
        es.load("popup")
    if not es.exists('script','vote'):
        es.load("vote")
    
    # Attempt to create the say command
    if not es.exists('saycommand','!prop'):
        es.regsaycmd('!prop','spawnprop/send_menu','Lets a person buy a prop.')
        
    # Create the popup
    current_spawnpopuppage = "spawnmenu%i"%current_page
    popup_page = popuplib.create(current_spawnpopuppage)
    popup_page.addline('[Spawn A Prop]')
    popup_page.addline('Please select a prop you would wish to spawn.')
    popup_page.addline('--------------------')
    popup_page.menuselect = get_key_values
    temp_keygroup = keyvalues.getKeyGroup('proplist')
    for temp_prop in temp_keygroup:
        build_popup(temp_prop)
    finish_popup()
    
def build_popup(temp_prop):
    global current_line
    global current_spawnpopuppage
    global current_page
    global isthereanextpage
    global popup_page
    prop_cost = es.keygetvalue('proplist',temp_prop,'cost')
    current_spawnpopuppage = "spawnmenu%i"%current_page
    current_line += 1
    if current_line < 8:
        popup_page.addline('->%s. %s ($%s)'%(current_line,temp_prop,prop_cost))
        popup_page.menuvalue('which_prop',current_line,temp_prop)
        isthereanextpage = 0
    else:
        isthereanextpage += 1
        finish_popup()
        current_page += 1
        
        current_line = 1
        current_spawnpopuppage = "spawnmenu%i"%current_page
        popup_page = popuplib.create(current_spawnpopuppage)
        popup_page.addline('[Spawn A Prop]')
        popup_page.addline('Please select the prop you wish to spawn.')
        popup_page.addline('--------------------')
        popup_page.menuselect = get_key_values
        
        popup_page.addline('->%s. %s ($%s)'%(current_line,temp_prop,prop_cost))
        popup_page.menuvalue('which_prop',current_line,temp_prop)
		
def finish_popup():
    global current_page
    global popup_page
    if current_page == 1:
        if isthereanextpage > 0:
            popup_page.addline('--------------------')
            popup_page.addline(' ')
            popup_page.addline('->9. Next')
            popup_page.addline('0. Cancel')
            next_spawnmenu = current_page + 1
            next_spawnmenu = "spawnmenu%i"%next_spawnmenu
            popup_page.submenu(9,next_spawnmenu)
        else:
            popup_page.addline('--------------------')
            popup_page.addline(' ')
            popup_page.addline(' ')
            popup_page.addline('0. Cancel')
    else:
        if isthereanextpage > 0:
            popup_page.addline('--------------------')
            popup_page.addline('->8. Back')
            popup_page.addline('->9. Next')
            popup_page.addline('0. Cancel')
            previous_spawnmenu = current_page - 1
            next_spawnmenu = current_page + 1
            previous_spawnmenu = "spawnmenu%i"%previous_spawnmenu
            next_spawnmenu = "spawnmenu%i"%next_spawnmenu
            popup_page.submenu(8,previous_spawnmenu)
            popup_page.submenu(9,next_spawnmenu)
        else:
            popup_page.addline('--------------------')
            popup_page.addline('->8. Back')
            popup_page.addline(' ')
            popup_page.addline('0. Cancel')
            previous_spawnmenu = current_page - 1
            previous_spawnmenu = "spawnmenu%i"%previous_spawnmenu
            popup_page.submenu(8,previous_spawnmenu)
    popup_page.timeout('view',30)
    popup_page.menuselect = get_key_values

def player_activate(event_var):
    userid = int(event_var['userid'])
    PlayerDict[userid] = {'prop_spawns':0}

def player_disconnect(event_var):
    userid = int(event_var['userid'])
    PlayerDict[userid].clear()

def player_spawn(event_var):
    userid = int(event_var['userid'])
    PlayerDict[userid]['prop_spawns'] = 0

def get_key_values(userid, choice, popupid):
    if choice < 8:
        prop_spawns = PlayerDict[userid]['prop_spawns']
        if prop_spawns < max_spawns or max_spawns == 0:
            name = es.getplayername(userid)
            prop_cost = es.keygetvalue('proplist',es.ServerVar('which_prop'),'cost')
            prop_cost = int(prop_cost)
            current_money = es.getplayerprop(userid,"CCSPlayer.m_iAccount")
            if current_money >= prop_cost:
                current_money -= prop_cost
                es.setplayerprop(userid,"CCSPlayer.m_iAccount",current_money)
                prop_directory = es.keygetvalue('proplist',es.ServerVar('which_prop'),'directory')
                es.prop_physics_create(userid, prop_directory)
                PlayerDict[userid]['prop_spawns'] += 1
                popuplib.send('spawnmenu1', userid)
            else:
                es.tell(userid,'#green','You can not afford that right now.')
                popuplib.send('spawnmenu1', userid)
        else:    
            es.tell(userid,'#green','You have reached your maximum prop count, you can not spawn more until you re-spawn')
		
def round_start(event_var):
	es.msg('#multi','#green SpawnProp #lightgreen is running. Type #green !prop #lightgreen to bring up the prop menu.')

def send_menu():
	userid = es.getcmduserid()
	is_player_dead = playerlib.getPlayer(userid).get('isdead')
	if not is_player_dead:
		popuplib.send('spawnmenu1', userid)
	else:
		es.tell(userid,'#green','You must be alive to do this.')
